<template>
  <UDashboardNavbar title="Bestände" :badge="filteredRows.length">
    <template #right>
      <UInput
          id="searchinput"
          v-model="searchString"
          icon="i-heroicons-funnel"
          autocomplete="off"
          placeholder="Suche..."
          class="hidden lg:block"
          @keydown.esc="$event.target.blur()"
      >
        <template #trailing>
          <UKbd value="/" />
        </template>
      </UInput>

      <UButton @click="router.push(`/products/create`)">+ Artikel</UButton>
    </template>
  </UDashboardNavbar>

  <UDashboardToolbar>

    <template #right>
      <USelectMenu
          v-model="selectedColumns"
          icon="i-heroicons-adjustments-horizontal-solid"
          :options="templateColumns"
          multiple
          class="hidden lg:block"
          by="key"
      >
        <template #label>
          Spalten
        </template>
      </USelectMenu>
    </template>
  </UDashboardToolbar>
  <UTable
      :rows="filteredRows"
      :columns="columns"
      class="w-full"
      :ui="{ divide: 'divide-gray-200 dark:divide-gray-800' }"
      @select="(i) => router.push(`/products/show/${i.id}`) "
      :empty-state="{ icon: 'i-heroicons-circle-stack-20-solid', label: 'Keine Artikel anzuzeigen' }"
  >
    <template #name-data="{row}">
      <span
          v-if="row === filteredRows[selectedItem]"
          class="text-primary-500 font-bold">{{row.name}}</span>
      <span v-else>
        {{row.name}}
      </span>

    </template>
    <template #stock-data="{row}">
      {{`${dataStore.getStockByProductId(row.id)} ${(dataStore.units.find(unit => unit.id === row.unit) ? dataStore.units.find(unit => unit.id === row.unit).name : "")}`}}
    </template>

  </UTable>

</template>

<script setup>

definePageMeta({
  middleware: "auth"
})

defineShortcuts({
  '/': () => {
    document.getElementById("searchinput").focus()
  },
  '+': () => {
    router.push("/products/create")
  },
  'Enter': {
    usingInput: true,
    handler: () => {
      router.push(`/products/show/${filteredRows.value[selectedItem.value].id}`)
    }
  },
  'arrowdown': () => {
    if(selectedItem.value < filteredRows.value.length - 1) {
      selectedItem.value += 1
    } else {
      selectedItem.value = 0
    }
  },
  'arrowup': () => {
    if(selectedItem.value === 0) {
      selectedItem.value = filteredRows.value.length - 1
    } else {
      selectedItem.value -= 1
    }
  }
})

const dataStore = useDataStore()
const router = useRouter()

const items = ref([])
const selectedItem = ref(0)

const setupPage = async () => {
  items.value = await useSupabaseSelect("products","*")
}

setupPage()


const templateColumns = [
  {
    key: "stock",
    label: "Bestand"
  },
  {
    key: "name",
    label: "Name",
    sortable: true
  },
]
const selectedColumns = ref(templateColumns)
const columns = computed(() => templateColumns.filter((column) => selectedColumns.value.includes(column)))

const templateTags = computed(() => {
  let temp = []

  dataStore.products.forEach(row => {
    row.tags.forEach(tag => {
      if(!temp.includes(tag)) temp.push(tag)
    })
  })

  return temp

})
const selectedTags = ref(templateTags.value)

const searchString = ref('')

const filteredRows = computed(() => {
  let temp = items.value.filter(i => i.tags.some(x => selectedTags.value.includes(x)) || i.tags.length === 0)

  return useSearch(searchString.value, temp)

})
</script>

<style scoped>

</style>